(function () {
    "use strict";

    angular.module('core').controller('entradaController', controller);
    controller.$inject = ['$scope', '$filter', 'pedidoCompraService', '$timeout', '$q', '$state', '$stateParams', 'lookupService', 'entradaService', '$alert', 'Upload', 'produtoService'];

    function controller($scope, $filter, pedidoCompraService, $timeout, $q, $state, $stateParams, lookupService, entradaService, $alert, Upload, produtoService) {
        $scope.initializeLayout('Entrada de Mercadorias');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            carregandoMais: false,
            salvando: false,
            vazio: false,
            count: 0,
            filtro: {}
        };
        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                NotaFiscal: {},
                save: function (action) {
                    $scope.state.salvando = true;

                    entradaService
                        .save($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ text: response.Message, title: $scope.Title });
                                } else {
                                    $scope.popups.add.ativo = false;
                                    $scope.popups.add.data = {};
                                    $scope.refresh();

                                    $state.go("state-entrada-edit", { id: response.Data.ID });
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                saveAction: {
                    save: 0,
                    saveAndNew: 1,
                    saveAndEdit: 2
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;
                    if ($scope.popups.add.ativo)
                        $scope.popups.add.prepare();
                },
                prepare: function () {
                    entradaService
                        .prepareNew()
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                    $scope.popups.add.ativo = false;
                                } else {
                                    $scope.popups.add.data = response.Data;
                                }
                            },
                            function (_error) {
                                $scope.popups.edit.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                fillChaveAcesso: function () {
                    entradaService
                        .fillChaveAcesso($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $timeout(function () { $("[ng-model*='popups.add.data.Emissao']").focus(); });
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                steps: {
                    index: 0,
                    count: 4,
                    next: function () {
                        if ($scope.popups.add.steps.customNext) {
                            $scope.popups.add.steps.customNext();
                        }
                        else {
                            if ($scope.popups.add.steps.index < ($scope.popups.add.steps.count - 1))
                                $scope.popups.add.steps.index++;
                        }
                    },
                    prior: function () {
                        if ($scope.popups.add.steps.customPrior) {
                            $scope.popups.add.steps.customPrior();
                        }
                        else {
                            if ($scope.popups.add.steps.index > 0)
                                $scope.popups.add.steps.index--;
                        }
                    }
                },

                importar: {
                    ativo: false,
                    carregando: false,
                    arquivo: { file: null, data: [], progressPercentage: 0, visible: true },
                    upload: function () {
                        var file = $scope.popups.add.importar.arquivo.file;
                        if (file && !file.$error) {
                            $scope.popups.add.importar.carregando = true;
                            Upload
                                .upload({ url: '/entrada/PrepareXml', data: { item: $scope.popups.add.data, file: file } })
                                .then(
                                    function (response) {
                                        /* o response do upload é um pouco diferente do promise */
                                        if (response.data.Status < 0)
                                            $alert({ text: response.data.Message, title: $scope.Title });
                                        else {
                                            $scope.popups.add.data = response.data.Data;
                                            $scope.popups.add.steps.next();
                                        }
                                        $scope.popups.add.importar.carregando = false;
                                    },
                                    function (_error) {
                                        $scope.popups.add.importar.carregando = false;
                                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                                    },
                                    function (event) { $scope.popups.add.importar.arquivo.progressPercentage = parseInt(100.0 * event.loaded / event.total); }
                                );
                        }
                    }
                }
            }
        };
        $scope.auxiliar = {
            tabelaPreco: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTabelaPreco({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            condicaoPagamento: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCondicaoPagamento({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            naturezaOperacao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllNaturezaOperacaoEntrada({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else {

                                    return response.Data;
                                }
                            })
                    );
                }
            },
            empresa: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllEmpresa({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            transportadora: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTransportadora({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            }
        };

        $scope.saveNewCompras = function () {

            pedidoCompraService
                .saveNewCompras($scope.popups.add.data.NotaFiscal, $scope.auxiliar.itemPedido.data)
                .then(
                    function (response) {
                        if (response.Status < 0)
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        else {
                            $scope.auxiliar.data = response.Data;
                            $state.go("state-entrada-detail", { codigo: response.Data.ID }, { reload: false, location: 'replace' });
                        }
                    },
                    function (error) { $scope.tools.toastr.error(error, 'Comunicação com o servidor'); }
                );
        };
        $scope.emiteEntradaPorXml = function () {
            $scope.state.carregando = true;
            entradaService
                .emiteEntradaPorXml($scope.popups.add.NotaFiscal, $scope.popups.add.data, $scope.index)
                .then(
                    function (response) {
                        if (response.Status < 0) {

                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            $scope.popups.add.steps.index = $scope.popups.add.steps.enum.xml;
                            console.error(response.Exception);

                        } else {

                            angular.copy(angular.fromJson(response.Data.entrada), $scope.popups.add.data);
                            $scope.state.Produto = {};
                            $scope.state.ProdutoBipado = "";
                            $scope.index = response.Data.index;
                            if ($scope.index == -1)
                                $state.go("state-entrada-edit", { id: $scope.popups.add.data.ID }, { reload: false, location: 'replace' });
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);

                    },
                    function (_error) {
                        $scope.state.carregando = false;

                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.IncluirItemEntrada = function (item, tamanho, codigobarra) {
            //entrada, nota, produto, variante, tamanho, codigobarra, index
            $scope.state.carregando = true;
            entradaService
                .IncluirItemEntrada($scope.popups.add.data, $scope.popups.add.NotaFiscal,
                    $scope.popups.add.Produto, item, tamanho, codigobarra, $scope.index)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                            $scope.state.carregando = false;
                        } else {

                            angular.copy(angular.fromJson(response.Data), $scope.popups.add.data);
                            $scope.index = $scope.index + 1;
                            $scope.emiteEntradaPorXml();
                        }
                        //   $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };

        $scope.statusSave = {
            EntradaMercadoria: {
                StatusManual: false
            }
        };
        $scope.encerrarEntrada = function () {

            entradaService.efetivarMovimentacao($scope.state.item).then(

                function (response) {
                    if (response.Status < 0)
                        $scope.tools.toastr.error(response.Message, "Serviço");
                    else {
                        $scope.tools.toastr.success("Entrada encerrada com sucesso", "Serviço");
                        $scope.get();
                    }
                }
            );
        }
        $scope.getInfoChaveNFe = function () {

            if ($scope.popups.add.data.NotaFiscal.Sefaz.Check) {
                if (angular.isUndefined($scope.popups.add.data.NotaFiscal) ||
                    angular.isUndefined($scope.popups.add.data.NotaFiscal.Sefaz) ||
                    angular.isUndefined($scope.popups.add.data.NotaFiscal.Sefaz.Chave)) {
                    $scope.tools.toastr.error('Insira a chave Sefaz.');
                    return;
                }

                entradaService.checkXml($scope.popups.add.data.NotaFiscal.Sefaz.Chave)
                    .then(
                        function (response) {

                            if (response.Status < 0) {
                                $scope.tools.toastr.error(response.Message, 'Chave NFE');
                                console.error('Chave NFE', response.Exception);
                            }
                            else {

                                if (angular.isUndefined($scope.popups.add.data.NotaFiscal.Serie))
                                    $scope.popups.add.data.NotaFiscal.Serie = {};


                                $scope.popups.add.data.NotaFiscal.Serie.Especie = response.Data.EspecieSerie;
                                $scope.popups.add.data.NotaFiscal.Codigo = response.Data.NotaFiscal;
                                $scope.popups.add.data.NotaFiscal.Serie.Codigo = response.Data.Serie;

                            }

                        },
                        function () {
                            $scope.tools.toastr.error('Ops! Não foi possível comunicar com o servidor.', 'Comunicação com o servidor');
                            console.error('Comunicação com o servidor', error);
                        }
                    )
            }
        };
        $scope.toggleAllItemPedido = function () {


            for (var i = 0; i < $scope.auxiliar.itemPedido.data.length; i++)
                $scope.auxiliar.itemPedido.data[i].Selecionado = $scope.auxiliar.itemPedido.data.select;

        };
        $scope.openupload = function () {
            document.getElementById('fileXml').click()
        }
        $scope.setQuantidadeItemPedido = function (index) {
            var row = $scope.auxiliar.itemPedido.data[index];
            row.Quantidade.Entregar = 0;
            for (var i = 0; i < row.Posicoes.length; i++)
                row.Quantidade.Entregar += row.Posicoes[i].Quantidade.Entregar;
            row.ValorTotal = row.Quantidade.Entregar * row.PrecoUnitario;
            row.Quantidade.Total = row.Quantidade.Entregar * row.PrecoUnitario;
        }
        $scope.SaveItemEntrada = function (item, tamanho) {
            $scope.IncluirItemEntrada(item, tamanho, null);
        };
        $scope.BuscarProduto = function () {
            produtoService
                .GetByCode($scope.state.ProdutoBipado)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {

                            if (response.Data.barcode == null || response.Data.barcode == "")
                                angular.copy(angular.fromJson(response.Data.produto), $scope.state.Produto);
                            else
                                $scope.IncluirItemEntrada(null, null, response.Data.barcode);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.enviarxml = function (file) {

            if (angular.isUndefined(file)) return;
            $scope.state.carregando = true;
            entradaService.prepareXml($scope.state.item).then(function () {
                file.upload = Upload.upload({
                    url: '/entrada/CreaeNotaFiscalXml',
                    data: { file: file }
                });

                file.upload.then(function (response) {

                    if (response.data.Status < 0)
                        $scope.tools.toastr.error(response.data.Message, "Atenção");
                    else {

                        $scope.popups.add.NotaFiscal = response.data.Data;
                        $scope.tools.toastr.success("Informação", "Nota Fiscal Gerada com Sucesso.");

                    }
                    $scope.state.carregando = false;

                }, function (response) {
                    $scope.state.carregando = false;
                    $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                });

            });
        }

        $scope.getPedidoCompras = function () {
            pedidoCompraService.getByPedidoCompra($scope.auxiliar.itemPedido.filtro).then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        angular.copy(angular.fromJson(response.Data), $scope.auxiliar.itemPedido.data);
                        $scope.auxiliar.itemPedido.vazio = ($scope.auxiliar.itemPedido.data == 0);
                    }
                },
                function (_error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                });
        };


        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.clearFilter();
            $scope.refresh();
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.filtro.args.sortExpression = 'CriadoEm DESC, Codigo';
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            entradaService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.count = function () {
            entradaService
                .count($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMore = function () {
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            entradaService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args = {
                chaves: '',
                filtro: null,
                filtroDe: null,
                filtroAte: null,
                sortExpression: '',
                skip: 0,
                take: 20
            };
            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };


        /*Inicializa funções*/
        $scope.initialize();
        $scope.$watch('popups.add.importar.arquivo.file', function () {
            /* verifica se o arquivo foi preenchido para upload e chama o upload */
            $scope.popups.add.importar.upload();
        });

    }

})();